/*
==================================================================================
  Copyright (c) 2021 Samsung

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

   This source code is part of the near-RT RIC (RAN Intelligent Controller)
   platform project (RICP).
==================================================================================
*/
// Code generated by go-swagger; DO NOT EDIT.

package a1_mediator

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"
)

// A1ControllerDeletePolicyTypeNoContentCode is the HTTP code returned for type A1ControllerDeletePolicyTypeNoContent
const A1ControllerDeletePolicyTypeNoContentCode int = 204

/*A1ControllerDeletePolicyTypeNoContent policy type successfully deleted


swagger:response a1ControllerDeletePolicyTypeNoContent
*/
type A1ControllerDeletePolicyTypeNoContent struct {
}

// NewA1ControllerDeletePolicyTypeNoContent creates A1ControllerDeletePolicyTypeNoContent with default headers values
func NewA1ControllerDeletePolicyTypeNoContent() *A1ControllerDeletePolicyTypeNoContent {

	return &A1ControllerDeletePolicyTypeNoContent{}
}

// WriteResponse to the client
func (o *A1ControllerDeletePolicyTypeNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// A1ControllerDeletePolicyTypeBadRequestCode is the HTTP code returned for type A1ControllerDeletePolicyTypeBadRequest
const A1ControllerDeletePolicyTypeBadRequestCode int = 400

/*A1ControllerDeletePolicyTypeBadRequest Policy type cannot be deleted because there are instances All instances must be removed before a policy type can be deleted


swagger:response a1ControllerDeletePolicyTypeBadRequest
*/
type A1ControllerDeletePolicyTypeBadRequest struct {
}

// NewA1ControllerDeletePolicyTypeBadRequest creates A1ControllerDeletePolicyTypeBadRequest with default headers values
func NewA1ControllerDeletePolicyTypeBadRequest() *A1ControllerDeletePolicyTypeBadRequest {

	return &A1ControllerDeletePolicyTypeBadRequest{}
}

// WriteResponse to the client
func (o *A1ControllerDeletePolicyTypeBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(400)
}

// A1ControllerDeletePolicyTypeNotFoundCode is the HTTP code returned for type A1ControllerDeletePolicyTypeNotFound
const A1ControllerDeletePolicyTypeNotFoundCode int = 404

/*A1ControllerDeletePolicyTypeNotFound policy type not found


swagger:response a1ControllerDeletePolicyTypeNotFound
*/
type A1ControllerDeletePolicyTypeNotFound struct {
}

// NewA1ControllerDeletePolicyTypeNotFound creates A1ControllerDeletePolicyTypeNotFound with default headers values
func NewA1ControllerDeletePolicyTypeNotFound() *A1ControllerDeletePolicyTypeNotFound {

	return &A1ControllerDeletePolicyTypeNotFound{}
}

// WriteResponse to the client
func (o *A1ControllerDeletePolicyTypeNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(404)
}

// A1ControllerDeletePolicyTypeServiceUnavailableCode is the HTTP code returned for type A1ControllerDeletePolicyTypeServiceUnavailable
const A1ControllerDeletePolicyTypeServiceUnavailableCode int = 503

/*A1ControllerDeletePolicyTypeServiceUnavailable Potentially transient backend database error. Client should attempt to retry later.

swagger:response a1ControllerDeletePolicyTypeServiceUnavailable
*/
type A1ControllerDeletePolicyTypeServiceUnavailable struct {
}

// NewA1ControllerDeletePolicyTypeServiceUnavailable creates A1ControllerDeletePolicyTypeServiceUnavailable with default headers values
func NewA1ControllerDeletePolicyTypeServiceUnavailable() *A1ControllerDeletePolicyTypeServiceUnavailable {

	return &A1ControllerDeletePolicyTypeServiceUnavailable{}
}

// WriteResponse to the client
func (o *A1ControllerDeletePolicyTypeServiceUnavailable) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(503)
}
